<?php
    ini_set('memory_limit', '1024M');
    ini_set('pcre.jit', '0');
    class Photos {
        private $workdir = "";
        private $library_path = false;
        private $database_path = false;
        private $clear_description = false;
        private $prefs_keepheic = false;
        private $db_link = null;
        private $perception_mode = false;
        private $file_volume_array = array();
        private $library_version = 4;
        
        public function __construct($library_path, $workdir, $fullscan, $clear_description, $prefs_mode, $prefs_keepheic) {
            $this->workdir = trim($workdir);
            $this->library_path = trim($library_path);
            @unlink("/tmp/Library_tmp.apdb");
            if(is_readable($this->library_path."/database/Photos.sqlite")) {
                echo "DATABASE ".$this->library_path."/database/Photos.sqlite\n";
                copy ($this->library_path."/database/Photos.sqlite", "/tmp/Library_tmp.apdb");
            } elseif(is_readable($this->library_path."/database/Library.apdb")) {
                echo "DATABASE ".$this->library_path."/database/Library.apdb\n";
                copy ($this->library_path."/database/Library.apdb", "/tmp/Library_tmp.apdb");
            } elseif(is_readable($this->library_path."/database/photos.db")) {
                echo "DATABASE ".$this->library_path."/database/photos.db\n";
                copy ($this->library_path."/database/photos.db", "/tmp/Library_tmp.apdb");
            } else {
                echo "database files not available or unreadable.";
                die();
            }
            //$this->database_path = $this->library_path."/database/Library.apdb";
            $this->database_path = "/tmp/Library_tmp.apdb";
            @unlink($this->workdir."joblist.txt");
            $this->populate_file_volume_array();
            
            if (trim($fullscan) != "false") {
                echo "DEBUG: create uuid fullscan (".$fullscan.")";
                $this->create_uuid_list(trim($fullscan));
            }
            
            if (trim($clear_description) == "true") {
                $this->clear_description = true;
            }
            
            if (trim($prefs_keepheic) == "true") {
                $this->prefs_keepheic = true;
            }
            
            if (trim($prefs_mode) == "perceptive") {
                $this->perception_mode = true;
                echo "NOTICE! Run in perception mode.\n";
            }
            
            $this->process_uuid_list();
            
            $this->create_albums_list();
            
            unlink ($this->database_path);
        }
        
        private function create_albums_list()
        {
            if ($this->connect_database())
            {
                if ($this->library_version == "6")
                {
                    echo "CREATE ALBUMS LIST\n";
                    $handle = $this->db_link->prepare("select Z_ENT from Z_PRIMARYKEY where Z_NAME='Album';");
                    
                    $handle->execute();
                    
                    $result = $handle->fetchAll(\PDO::FETCH_OBJ);
                    var_dump($result);
                    if ($result)
                    {
                        foreach($result as $row)
                        {
                            $ALBUM_Z = $row->Z_ENT;
                        }
                    }
                    else
                    {
                        $ALBUM_Z = "26";
                    }
                    
                    echo "ALBUM_Z: ${ALBUM_Z}\n";
                    
                    $handle = $this->db_link->prepare("select Z_ENT from Z_PRIMARYKEY where Z_NAME='Asset';");
                    
                    $handle->execute();
                    
                    $result = $handle->fetchAll(\PDO::FETCH_OBJ);
                    var_dump($result);
                    if ($result)
                    {
                        foreach($result as $row)
                        {
                            $ASSET_Z = $row->Z_ENT;
                        }
                    }
                    else
                    {
                        $ASSET_Z = "3";
                    }
                    
                    echo "ASSET_Z: ${ASSET_Z}\n";
                    
                    $handle = $this->db_link->prepare("SELECT ZGENERICALBUM.ZUUID as albumId, ZASSET.ZUUID as photoId, ZGENERICALBUM.ZTITLE, Z_${ALBUM_Z}ASSETS.Z_${ASSET_Z}ASSETS FROM ZGENERICALBUM JOIN Z_${ALBUM_Z}ASSETS JOIN ZASSET WHERE ZGENERICALBUM.ZKIND=2 AND ZGENERICALBUM.ZTRASHEDSTATE=0 AND Z_${ALBUM_Z}ASSETS.Z_${ALBUM_Z}ALBUMS=ZGENERICALBUM.Z_PK AND ZASSET.Z_PK = Z_${ALBUM_Z}ASSETS.Z_${ASSET_Z}ASSETS;");
                    
                    $handle->execute();
                    
                    $result = $handle->fetchAll(\PDO::FETCH_OBJ);
                    var_dump($result);
                    //var_dump($result);
                    
                    if ($result)
                    {
                        mkdir("albums");
                        
                        foreach($result as $row)
                        {
                            $albumId = $row->albumId."/L0/040";
                            $photoId = $row->photoId;
                            
                           // var_dump ($row);
                            
                            $dir = "albums/".substr($photoId, 0,3)."/";
                            
                            if (!is_dir($dir))
                            {
                                mkdir($dir);
                            }
                            
                            file_put_contents("${dir}${photoId}", "${albumId},", FILE_APPEND);
                        }
                    }
                }
                elseif ($this->library_version == "5") {
                    echo "CREATE ALBUMS LIST\n";
                    
                    $handle = $this->db_link->prepare("select Z_ENT from Z_PRIMARYKEY where Z_NAME='Album';");
                    
                    $handle->execute();
                    
                    $result = $handle->fetchAll(\PDO::FETCH_OBJ);
                    
                    if ($result)
                    {
                        foreach($result as $row)
                        {
                            $ALBUM_Z = $row->Z_ENT;
                        }
                    }
                    else
                    {
                        $ALBUM_Z = "26";
                    }
                    
                    
                    $handle = $this->db_link->prepare("select Z_ENT from Z_PRIMARYKEY where Z_NAME='GenericAsset';");
                    
                    $handle->execute();
                    
                    $result = $handle->fetchAll(\PDO::FETCH_OBJ);
                    
                    if ($result)
                    {
                        foreach($result as $row)
                        {
                            $ASSET_Z = $row->Z_ENT;
                        }
                    }
                    else
                    {
                        $ASSET_Z = "34";
                    }
                    
                    $handle = $this->db_link->prepare("SELECT ZGENERICALBUM.ZUUID as albumId, ZGENERICASSET.ZUUID as photoId, ZGENERICALBUM.ZTITLE, Z_${ALBUM_Z}ASSETS.Z_${ASSET_Z}ASSETS FROM ZGENERICALBUM JOIN Z_${ALBUM_Z}ASSETS JOIN ZGENERICASSET WHERE ZGENERICALBUM.ZKIND=2 AND ZGENERICALBUM.ZTRASHEDSTATE=0 AND Z_${ALBUM_Z}ASSETS.Z_${ALBUM_Z}ALBUMS=ZGENERICALBUM.Z_PK AND ZGENERICASSET.Z_PK = Z_${ALBUM_Z}ASSETS.Z_${ASSET_Z}ASSETS;");
                    
                    $handle->execute();
                    
                    $result = $handle->fetchAll(\PDO::FETCH_OBJ);
                    
                    //var_dump($result);
                    
                    if ($result)
                    {
                        mkdir("albums");
                        
                        foreach($result as $row)
                        {
                            $albumId = $row->albumId."/L0/040";
                            $photoId = $row->photoId;
                            
                           // var_dump ($row);
                            
                            $dir = "albums/".substr($photoId, 0,3)."/";
                            
                            if (!is_dir($dir))
                            {
                                mkdir($dir);
                            }
                            
                            file_put_contents("${dir}${photoId}", "${albumId},", FILE_APPEND);
                        }
                    }
                }
            }
        }
        
        private function create_uuid_list($limit) {
            if ($this->connect_database()) {
                /* den här gör ingenting än så länge
                 if ($this->clear_description) {
                 $handle = $this->db_link->prepare('update RKVersion set extendedDescription=? where isInTrash = ?');
                 
                 $handle->bindValue(1, "");
                 $handle->bindValue(2, 0);
                 
                 $handle->execute();
                 }
                 */
                
                if (trim($limit) == "true") {
                    $limit=10000000;
                }
                
                if ($this->library_version == "6"){
                    $handle = $this->db_link->prepare('select ZUUID from ZASSET where ZTRASHEDSTATE=0 AND ZVISIBILITYSTATE = 0 limit ?'); //ZVISIBILITYSTATE =0 för att returnera samma antal bilder som finns i biblioteket (kan ha med shared att göra) 8.0.2 plockade bort AND ZCLOUDLOCALSTATE = 1 
                    
                    $handle->bindValue(1, $limit);
                    
                    $handle->execute();
                    
                    $result = $handle->fetchAll(\PDO::FETCH_OBJ);
                    
                   // echo "debug dump\n";
                    //var_dump($result);
                    
                    if (count($result) == 0) {
                        $handle = $this->db_link->prepare('select ZUUID from ZASSET where ZTRASHEDSTATE=0 AND ZVISIBILITYSTATE = 0 limit ?'); //ZVISIBILITYSTATE =0 för att returnera samma antal bilder som finns i biblioteket (kan ha med shared att göra)
                        
                        $handle->bindValue(1, $limit);
                        
                        $handle->execute();
                        
                        $result = $handle->fetchAll(\PDO::FETCH_OBJ);
                       
                    }
                    
                    if ($result) {
                        $i=0;
                        foreach($result as $row){
                            $i++;
                            $master_uuid = $row->ZUUID;
                            echo "\n".$i." ".$master_uuid."\n";
                            $this->write($this->workdir."uuid_list.txt", $master_uuid);
                        }
                    }
                    //die();
                } elseif ($this->library_version == "5"){
                    $handle = $this->db_link->prepare('select ZUUID from ZGENERICASSET where ZTRASHEDSTATE=? AND ZVISIBILITYSTATE =0 limit ?');
                    
                    $handle->bindValue(1, 0);
                    $handle->bindValue(2, $limit);
                    
                    $handle->execute();
                    
                    $result = $handle->fetchAll(\PDO::FETCH_OBJ);
                    
                    if ($result) {
                        foreach($result as $row){
                            $master_uuid = $row->ZUUID;
                            $this->write($this->workdir."uuid_list.txt", $master_uuid);
                        }
                    }
                    //die();
                } else {
                    $handle = $this->db_link->prepare('select uuid from RKVersion where isInTrash = ? limit ?');
                    
                    $handle->bindValue(1, 0);
                    $handle->bindValue(2, $limit);
                    
                    $handle->execute();
                    
                    $result = $handle->fetchAll(\PDO::FETCH_OBJ);
                    
                    if ($result) {
                        foreach($result as $row){
                            $master_uuid = $row->uuid;
                            $this->write($this->workdir."uuid_list.txt", $master_uuid);
                        }
                    }
                }
                
            } else {
                echo "ERROR! failed to connect to database.";
                die();
            }
        }
        
        private function process_uuid_list() {
            $hasFileVolumeColumn = false;
            
            if ($this->connect_database()) {
                $handle = $this->db_link->prepare("PRAGMA table_info('RKMaster')");
                $handle->execute();
                
                $result = $handle->fetchAll(\PDO::FETCH_OBJ);
                
                if ($result) {
                    foreach($result as $row){
                        $name = $row->name;
                        if ($name == "fileVolumeUuid") {
                            $hasFileVolumeColumn = true;
                        }
                        echo $name."\n";
                    }
                }
                
                $stream = new SplFileObject($this->workdir."uuid_list.txt");
                
                while (!$stream->eof()) {
                    
                    $version_uuid = trim($stream->fgets());
                    
                    if (preg_match("/([A-Z0-9]{8}\-[A-Z0-9]{4}\-[A-Z0-9]{4}\-[A-Z0-9]{4}\-[A-Z0-9]{12})/", $version_uuid, $tmp)) {
                        $version_uuid = $tmp[1];
                    }
                    
                    echo "LOG version: ${version_uuid} ".strlen($version_uuid)." ".$this->library_version."\n";
                    
                    if ($this->library_version == "6"){
                     echo "A";
                        if (strlen($version_uuid) == 36) {
                            echo "B";
                            $handle = $this->db_link->prepare('select * from ZASSET where ZUUID = ? limit 1');
                            
                            $handle->bindValue(1, $version_uuid);
                            
                            $handle->execute();
                            
                            $result = $handle->fetchAll(\PDO::FETCH_OBJ);
                            
                            //var_dump($result);
                            
                            if ($result) {
                                foreach($result as $row){
                                    $z_pk = $row->Z_PK;
                                    $filename = $row->ZFILENAME;
                                    // print_r($row);
                                }
                            }
                           // $handle = $this->db_link->prepare('select ZPUBLICGLOBALUUID, ZORIGINALFILENAME, ZORIGINALFILESIZE, ZADJUSTEDFINGERPRINT, ZORIGINALWIDTH, ZORIGINALHEIGHT from ZADDITIONALASSETATTRIBUTES where Z_PK = ? limit 1');
                            
                            $handle = $this->db_link->prepare('select ZMASTERFINGERPRINT, ZEXIFTIMESTAMPSTRING, ZPUBLICGLOBALUUID, ZORIGINALFILENAME, ZORIGINALFILESIZE, ZADJUSTEDFINGERPRINT, ZORIGINALWIDTH, ZORIGINALHEIGHT from ZADDITIONALASSETATTRIBUTES where ZASSET = ? limit 1'); //6.1.0, 7.5.0
                            
                            
                            $handle->bindValue(1, $z_pk);
                            
                            $handle->execute();
                            
                            $result = $handle->fetchAll(\PDO::FETCH_OBJ);
                            
                           // echo "\n---------\n";
                           // var_dump($result);
                           // echo "\n---------\n";
                            if ($result) {
                                foreach($result as $row){
                                    $masterFilesize = $row->ZORIGINALFILESIZE;
                                    $masterWidth = $row->ZORIGINALWIDTH;
                                    $masterHeight = $row->ZORIGINALHEIGHT;
                                    $adjustment_uuid = $row->ZADJUSTEDFINGERPRINT;
                                    $originalFilename = $row->ZORIGINALFILENAME;
                                    $fingerprint = $row->ZMASTERFINGERPRINT; //7.5.0
                                    $timestamp = $row->ZEXIFTIMESTAMPSTRING; //7.5.0
                                    //     print_r($row);
                                }
                            }
                            
                            if ($this->prefs_keepheic) {
                                if (preg_match("/.*\.HEIC$/i", $originalFilename)) {
                                    $masterFilesize = $masterFilesize*12;
                                }
                            }
                            echo "${originalFilename} $version_uuid:${version_uuid} masterFilesize:${masterFilesize}\n";
                            
                            if ($hasFileVolumeColumn) {
                                $fileVolumeUuid = $row->fileVolumeUuid;
                            } else {
                                $fileVolumeUuid = null;
                            }
                            //var_dump($row);
                            
                            if ($this->perception_mode) {
                                // resources/derivatives/masters/
                                $full_path = glob($this->library_path."/resources/derivatives/masters/".substr($version_uuid, 0, 1)."/".$version_uuid."*")[0];
                            } else {
                                if ($fileVolumeUuid == null) {
                                    // TODO verifier att vi verkligen hamnar här!
                                    $full_path = $this->library_path."/originals/".substr($version_uuid, 0, 1)."/".$filename;
                                } else {
                                    $full_path = "/Volumes/".$this->file_volume_array[$fileVolumeUuid]."/".$imagePath;
                                }
                            }
                            
                            $uuid_addon = "/L0/001";
                            
                            $this->write("joblist.txt", $version_uuid.$uuid_addon."%BREAKPOINT%".$full_path."%BREAKPOINT%".$adjustment_uuid."%BREAKPOINT%".$masterFilesize."%BREAKPOINT%".$masterWidth."%BREAKPOINT%".$masterHeight."%BREAKPOINT%".$fingerprint."%BREAKPOINT%".$timestamp."%BREAKPOINT%".$originalFilename);
                        }
                        
                    } elseif ($this->library_version == "5"){
                        echo "A";
                        if (strlen($version_uuid) == 36) {
                            echo "B";
                            $handle = $this->db_link->prepare('select * from ZGENERICASSET where ZUUID = ? limit 1');
                            
                            $handle->bindValue(1, $version_uuid);
                            
                            $handle->execute();
                            
                            $result = $handle->fetchAll(\PDO::FETCH_OBJ);
                            
                            //var_dump($result);
                            
                            if ($result) {
                                foreach($result as $row){
                                    $z_pk = $row->Z_PK;
                                    $filename = $row->ZFILENAME;
                                    // print_r($row);
                                }
                            }
                            $handle = $this->db_link->prepare('select ZMASTERFINGERPRINT, ZEXIFTIMESTAMPSTRING, ZPUBLICGLOBALUUID, ZORIGINALFILENAME, ZORIGINALFILESIZE, ZADJUSTEDFINGERPRINT, ZORIGINALWIDTH, ZORIGINALHEIGHT from ZADDITIONALASSETATTRIBUTES where ZASSET = ? limit 1'); // 7.5.0
                            
                            $handle->bindValue(1, $z_pk);
                            
                            $handle->execute();
                            
                            $result = $handle->fetchAll(\PDO::FETCH_OBJ);
                            
                           // echo "\n---------\n";
                           // var_dump($result);
                           // echo "\n---------\n";
                            if ($result) {
                                foreach($result as $row){
                                    $masterFilesize = $row->ZORIGINALFILESIZE;
                                    $masterWidth = $row->ZORIGINALWIDTH;
                                    $masterHeight = $row->ZORIGINALHEIGHT;
                                    $adjustment_uuid = $row->ZADJUSTEDFINGERPRINT;
                                    $originalFilename = $row->ZORIGINALFILENAME;
                                    $fingerprint = $row->ZMASTERFINGERPRINT; //7.5.0
                                    $timestamp = $row->ZEXIFTIMESTAMPSTRING; //7.5.0
                                    //     print_r($row);
                                }
                            }
                            
                            if ($this->prefs_keepheic) {
                                if (preg_match("/.*\.HEIC$/i", $originalFilename)) {
                                    $masterFilesize = $masterFilesize*12;
                                }
                            }
                            echo "${originalFilename} $version_uuid:${version_uuid} masterFilesize:${masterFilesize}\n";
                            
                            if ($hasFileVolumeColumn) {
                                $fileVolumeUuid = $row->fileVolumeUuid;
                            } else {
                                $fileVolumeUuid = null;
                            }
                            //var_dump($row);
                            
                            if ($this->perception_mode) {
                                // resources/derivatives/masters/
                                $full_path = glob($this->library_path."/resources/derivatives/masters/".substr($version_uuid, 0, 1)."/".$version_uuid."*")[0];
                            } else {
                                if ($fileVolumeUuid == null) {
                                    // TODO verifier att vi verkligen hamnar här!
                                    $full_path = $this->library_path."/originals/".substr($version_uuid, 0, 1)."/".$filename;
                                } else {
                                    $full_path = "/Volumes/".$this->file_volume_array[$fileVolumeUuid]."/".$imagePath;
                                }
                            }
                            
                            $uuid_addon = "/L0/001";
                            
                            $this->write("joblist.txt", $version_uuid.$uuid_addon."%BREAKPOINT%".$full_path."%BREAKPOINT%".$adjustment_uuid."%BREAKPOINT%".$masterFilesize."%BREAKPOINT%".$masterWidth."%BREAKPOINT%".$masterHeight."%BREAKPOINT%".$fingerprint."%BREAKPOINT%".$timestamp."%BREAKPOINT%".$originalFilename);
                        }
                        
                    } else {
                        if (strlen($version_uuid) == 22) {
                            $handle = $this->db_link->prepare('select masterHeight, masterWidth, modelId, masterUuid, adjustmentUuid from RKVersion where uuid = ? limit 1');
                            
                            $handle->bindValue(1, $version_uuid);
                            
                            $handle->execute();
                            
                            $result = $handle->fetchAll(\PDO::FETCH_OBJ);
                            
                            if ($result) {
                                foreach($result as $row){
                                    
                                    $modelId = $row->modelId;
                                    $masterWidth = $row->masterWidth;
                                    $masterHeight = $row->masterHeight;
                                    $master_uuid = $row->masterUuid;
                                    $adjustment_uuid = $row->adjustmentUuid;
                                }
                            }
                            
                            if ($hasFileVolumeColumn) {
                                $handle = $this->db_link->prepare('select fileName,fileSize,imagePath,fileVolumeUuid from RKMaster where uuid = ? limit 1');
                            } else {
                                $handle = $this->db_link->prepare('select fileName,fileSize,imagePath from RKMaster where uuid = ? limit 1');
                            }
                            $handle->bindValue(1, $master_uuid);
                            
                            $handle->execute();
                            
                            $result = $handle->fetchAll(\PDO::FETCH_OBJ);
                            
                            if ($result) {
                                foreach($result as $row){
                                    
                                    // print_r($row);
                                    
                                    $imagePath = $row->imagePath;
                                    $masterFilesize = $row->fileSize;
                                    
                                    $filename = $row->fileName;
                                    if ($this->prefs_keepheic) {
                                        if (preg_match("/.*\.HEIC$/i", $filename)) {
                                            $masterFilesize = $masterFilesize*12;
                                        }
                                    }
                                    echo "$version_uuid:${version_uuid} masterFilesize:${masterFilesize}\n";
                                    
                                    
                                    if ($hasFileVolumeColumn) {
                                        $fileVolumeUuid = $row->fileVolumeUuid;
                                    } else {
                                        $fileVolumeUuid = null;
                                    }
                                    //var_dump($row);
                                    
                                    if ($this->perception_mode) {
                                        $modelId_hex = dechex($modelId);
                                        $modelId_hex_padded = str_pad($modelId_hex, 6, "0", STR_PAD_LEFT);
                                        
                                        $path = substr($modelId_hex_padded, 2,2)."/".substr($modelId_hex_padded, 0,2)."/".$modelId_hex."/";
                                        
                                        $full_path = $this->library_path."/resources/proxies/derivatives/".substr($modelId_hex_padded, 2,2)."/".substr($modelId_hex_padded, 0,2)."/".$modelId_hex."/".$adjustment_uuid."_mini_".dechex($modelId).".jpg";
                                        
                                        //print_r($full_path);
                                    } else {
                                        if ($fileVolumeUuid == null) {
                                            // TODO verifier att vi verkligen hamnar här!
                                            $full_path = $this->library_path."/Masters/".$imagePath;
                                        } else {
                                            $full_path = "/Volumes/".$this->file_volume_array[$fileVolumeUuid]."/".$imagePath;
                                        }
                                    }
                                }
                            }
                            
                            $this->write("joblist.txt", $version_uuid."%BREAKPOINT%".$full_path."%BREAKPOINT%".$adjustment_uuid."%BREAKPOINT%".$masterFilesize."%BREAKPOINT%".$masterWidth."%BREAKPOINT%".$masterHeight);
                        }
                    }
                }
                $stream = null;
            } else {
                echo "ERROR! failed to connect to database.";
                die();
            }
        }
        
        private function populate_file_volume_array() {
            try {
                if ($this->connect_database()) {
                    $handle = $this->db_link->prepare('SELECT name FROM sqlite_master WHERE type=? AND name=?');
                    $handle->bindValue(1, 'table');
                    $handle->bindValue(2, 'RKVolume');
                    
                    $handle->execute();
                    
                    $result = $handle->fetchAll(\PDO::FETCH_OBJ);
                    
                    if (!$result) {
                        return false;
                    }
                    
                    $handle = $this->db_link->prepare('SELECT uuid,name FROM RKVolume');
                    
                    $handle->execute();
                    
                    $result = $handle->fetchAll(\PDO::FETCH_OBJ);
                    
                    if ($result) {
                        foreach($result as $row){
                            $this->file_volume_array[$row->uuid] = $row->name;
                        }
                    }
                    
                    $this->db_link = null;
                    
                } else {
                    $this->log("DB connection failed");
                    return false;
                }
                
            }
            catch(\PDOException $ex){
                $this->log($ex->getMessage());
                return false;
            }
        }
        
        private function connect_database() {
            try {
                $this->db_link = new \PDO("sqlite:".$this->database_path);
                
                $this->db_link->setAttribute(PDO::ATTR_ERRMODE,
                                             PDO::ERRMODE_EXCEPTION);
                
                $handle = $this->db_link->prepare('SELECT name FROM sqlite_master WHERE type=? AND name=?');
                $handle->bindValue(1, 'table');
                $handle->bindValue(2, 'ZGENERICASSET');
                
                $handle->execute();
                
                $result = $handle->fetchAll(\PDO::FETCH_OBJ);
                
                if ($result) {
                    $this->library_version = "5";
                }
            }
            catch(\PDOException $ex) {
                $this->log($ex->getMessage());
                return false;
            }
           
        try {
                $this->db_link = new \PDO("sqlite:".$this->database_path);
                
                $this->db_link->setAttribute(PDO::ATTR_ERRMODE,
                                            PDO::ERRMODE_EXCEPTION);
                
                $handle = $this->db_link->prepare('SELECT name FROM sqlite_master WHERE type=? AND name=?');
                $handle->bindValue(1, 'table');
                $handle->bindValue(2, 'ZASSET');
                
                $handle->execute();
                
                $result = $handle->fetchAll(\PDO::FETCH_OBJ);
                
                if ($result) {
                    $this->library_version = "6";
                }
            }
            catch(\PDOException $ex) {
                $this->log($ex->getMessage());
                return false;
            }
            return true;
        }
        
        private function write($name, $string) {
            echo "\n".$name." : ".$string."\n";
            file_put_contents($name, $string."\n", FILE_APPEND);
        }
        
        private  function log($string) {
            echo "LOG : ".$string."\n";
        }
    }
    
  //  $Photos = new Photos("/Users/propaganda 1/Dropbox/Brattoo/Photos6/Photos Library.photoslibrary", "/Users/propaganda 1/Dropbox/Brattoo/Photos6/tmp/", "true", "false", "perceptive", "true");
    
    $Photos = new Photos($argv[1], $argv[2], $argv[3], $argv[4], $argv[5], $argv[6]);
    
